/usr/bin/smpirun is in libsimgrid-dev 3.11.1-9.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 | #! /bin/sh
# Copyright (c) 2007-2014. The SimGrid Team.
# All rights reserved.
# This program is free software; you can redistribute it and/or modify it
# under the terms of the license (GNU LGPL) which comes with this package.
export LD_LIBRARY_PATH="/usr/lib:${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH}"
DEFAULT_LOOPBACK_BANDWIDTH="498000000"
DEFAULT_LOOPBACK_LATENCY="0.000004"
DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))"
DEFAULT_NETWORK_LATENCY="0.000005"
DEFAULT_NUMPROCS="4"
DEFAULT_POWER="100"
LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
POWER="${DEFAULT_POWER}"
SIMOPTS="--cfg=maxmin/precision:1e-3 --cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304"
#usage to print the way this script should be called
usage () {
cat <<EOF
Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
Options:
-keep-temps # don't remove the generated files after execution
-wrapper <command> # use command to run the program (e.g. "valgrind")
-map # display the machine on which each process rank is mapped
-np <numprocs> # use that amount of processes from the hostfile.
# By default, all processes of the hostfile are used.
-trace-ti # activate time independant tracing (for replay, default in smpi_simgrid.txt)
-trace # activate tracing (Paje, default in smpi_simgrid.trace)
-trace-comment <comment> # put a comment on the top of the trace file
-trace-comment-file <file> # put file contents on the top of the trace file as comment
-trace-grouped # group MPI processes by location
-trace-resource # trace resource utilization
-trace-viva # generate configuration for Viva's GraphView
-trace-file <tracefile> # name of the tracefile (simgrid_smpi.trace)
-ext <value> # additional parameter (reserved)
or (deprecated usage):
$0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
EOF
}
#check if we have at least one parameter
if [ $# -eq 0 ]
then
usage
exit
fi
EXTOPT=""
WRAPPER=""
HOSTFILE=""
while true; do
case "$1" in
"-np" | "-n")
NUMPROCS="$2"
shift 2
;;
"-bandwidth")
NETWORK_BANDWIDTH="$2"
shift 2
;;
"-latency")
NETWORK_LATENCY="$2"
shift 2
;;
"-platform")
PLATFORM="$2"
if [ ! -f "${PLATFORM}" ]; then
echo "[$0] ** error: the file '${PLATFORM}' does not exist. Aborting."
exit 1
fi
shift 2
;;
"-hostfile")
HOSTFILE="$2"
if [ ! -f "${HOSTFILE}" ]; then
echo "[$0] ** error: the file '${HOSTFILE}' does not exist. Aborting."
exit 1
fi
shift 2
;;
"-machinefile")
HOSTFILE="$2"
if [ ! -f "${HOSTFILE}" ]; then
echo "[$0] ** error: the file '${HOSTFILE}' does not exist. Aborting."
exit 1
fi
shift 2
;;
"-ext")
EXTOPT="$2"
shift 2
;;
"-map")
MAPOPT="true"
shift 1
;;
"-trace")
TRACE_ACTIVE="true"
shift 1
;;
"-trace-ti")
TRACE_ACTIVE="true"
TRACE_TI_ACTIVE="true"
shift 1
;;
"-trace-comment")
TRACE_COMMENT="$2"
shift 2
;;
"-trace-comment-file")
TRACE_COMMENT_FILE="$2"
shift 2
;;
"-trace-file")
TRACE_FILENAME="$2"
shift 2
;;
"-trace-grouped")
TRACE_GROUPED="true"
shift 1
;;
"-trace-resource")
TRACE_RESOURCE="true"
shift 1
;;
"-trace-viva")
TRACE_VIVA="true"
shift 1
;;
"-keep-temps")
KEEP="true"
shift 1
;;
"-wrapper")
WRAPPER="$2"
shift 2
;;
"-help" | "--help" | "-h")
usage
exit
;;
"--cfg="*|"--log="*)
for OPT in ${1#*=}
do
SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
done
shift 1
;;
*)
break
;;
esac
done
if [ -n "$WRAPPER" ]; then
EXEC="$WRAPPER $1"
else
EXEC="$1"
fi
shift
# steel --cfg and --logs options
while [ $# -gt 0 ]; do
case "$1" in
"--cfg="*|"--log="*)
for OPT in ${1#*=}
do
SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
done
shift 1
;;
*)
PROC_ARGS="${PROC_ARGS:+$PROC_ARGS }$1"
shift
;;
esac
done
##-----------------------------------
if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
echo "No hostfile nor platform specified."
usage
exit 1
fi
HOSTFILETMP=0
if [ -z "${HOSTFILE}" ] ; then
HOSTFILETMP=1
HOSTFILE="$(mktemp tmphostXXXXXX)"
perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
fi
UNROLLEDHOSTFILETMP=0
#parse if our lines are terminated by :num_process
multiple_processes=`grep -c ":" $HOSTFILE`
if [ "${multiple_processes}" -gt 0 ] ; then
UNROLLEDHOSTFILETMP=1
UNROLLEDHOSTFILE="$(mktemp tmphostXXXXXX)"
perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/' ${HOSTFILE} > ${UNROLLEDHOSTFILE}
if [ ${HOSTFILETMP} = 1 ] ; then
rm ${HOSTFILE}
HOSTFILETMP=0
fi
HOSTFILE=$UNROLLEDHOSTFILE
fi
# Don't use wc -l to compute it to avoid issues with trailing \n at EOF
hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
if [ -z "${NUMPROCS}" ] ; then
# Use the amount of processes in the hostfile as default value for the -np parameter
NUMPROCS=$hostfile_procs
fi
if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
fi
##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
if [ -z "${PLATFORM}" ]; then
PLATFORMTMP="$(mktemp tmpXXXXXX)"
cat > ${PLATFORMTMP} <<PLATFORMHEAD
<?xml version='1.0'?>
<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
<platform version="3">
<AS id="AS0" routing="Full">
PLATFORMHEAD
i=${NUMPROCS}
while [ $i -gt 0 ]; do
echo " <host id=\"host$i\" power=\"${POWER}\"/>" >> ${PLATFORMTMP}
echo " <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
echo " <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
i=$((i - 1))
done
i=${NUMPROCS}
while [ $i -gt 0 ]; do
j=${NUMPROCS}
while [ $j -gt 0 ]; do
if [ $i -eq $j ]; then
echo " <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
else
echo " <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
fi
j=$((j - 1))
done
i=$((i - 1))
done
cat >> ${PLATFORMTMP} <<PLATFORMFOOT
</AS>
</platform>
PLATFORMFOOT
else
PLATFORMTMP=${PLATFORM}
fi
##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
##-------------------------------- DEFAULT APPLICATION --------------------------------------
APPLICATIONTMP="$(mktemp tmpXXXXXX)"
#APPLICATIONTMP="app.xml"
cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
<?xml version='1.0'?>
<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
<platform version="3">
APPLICATIONHEAD
##---- cache hostnames of hostfile---------------
if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
hostnames=$(cat ${HOSTFILE} | tr '\n\r' ' ')
NUMHOSTS=$(cat ${HOSTFILE} | wc -l)
fi
if [ "${EXTOPT}" = "smpi_replay" ]; then
APP_TRACES=$PROC_ARGS
if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
hosttraces=$(cat ${APP_TRACES} | tr '\n\r' ' ' )
NUMTRACES=$(cat ${APP_TRACES} | wc -l)
else
printf "File not found: %s\n", "${APP_TRACES:-\${APP_TRACES\}}" >&2
exit 1
fi
fi
##----------------------------------------------------------
## generate application.xml with hostnames from hostfile:
## the name of host_i (1<=i<=p, where -np p) is the line i
## in hostfile (where -hostfile hostfile), or "host$i" if
## hostfile has less than i lines.
##----------------------------------------------------------
HAVE_SEQ="`which seq 2>/dev/null`"
if [ -n "${HAVE_SEQ}" ]; then
SEQ=`${HAVE_SEQ} 0 $((${NUMPROCS}-1))`
else
cnt=0
while [ $cnt -lt ${NUMPROCS} ] ; do
SEQ="$SEQ $cnt"
cnt=$((cnt + 1));
done
fi
##---- generate <process> tags------------------------------
for i in ${SEQ}
do
if [ -n "${HOSTFILE}" ]; then
j=$(( $i % ${NUMHOSTS} + 1 ))
fi
##---- optional display of ranks to process mapping
if [ -n "${MAPOPT}" ]; then
echo "[rank $i] -> $(echo $hostnames|cut -d' ' -f$j)"
fi
if [ -z "$(echo $hostnames|cut -d' ' -f$j)" ]; then
host="host"$($j)
else
host="$(echo $hostnames|cut -d' ' -f$j)"
fi
echo " <process host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->" >> ${APPLICATIONTMP}
echo " <argument value=\"1\"/> <!-- instance -->" >> ${APPLICATIONTMP}
echo " <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
if [ "${EXTOPT}" = "smpi_replay" ]; then
if [ ${NUMTRACES} -gt 1 ]; then
echo " <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
else
echo " <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
fi
else
for ARG in $PROC_ARGS; do
echo " <argument value=\"${ARG}\"/>" >> ${APPLICATIONTMP}
done
fi
echo " </process>" >> ${APPLICATIONTMP}
done
cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
</platform>
APPLICATIONFOOT
##-------------------------------- end DEFAULT APPLICATION --------------------------------------
##---------------------- SMPI TRACING OPTIONS ---------------------------------
if [ -n "${TRACE_ACTIVE}" ]; then
#define trace filename
if [ -n "${TRACE_TI_ACTIVE}" ]; then
if [ -z "${TRACE_FILENAME}" ]; then
TRACE_FILENAME="smpi_simgrid.txt"
fi
TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes --cfg=tracing/smpi/format:TI --cfg=tracing/smpi/computing:yes"
else
if [ -z "${TRACE_FILENAME}" ]; then
TRACE_FILENAME="smpi_simgrid.trace"
fi
TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes"
fi
if [ -n "${TRACE_COMMENT}" ]; then
TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
fi
if [ -n "${TRACE_COMMENT_FILE}" ]; then
TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment_file:${TRACE_COMMENT_FILE}"
fi
if [ -n "${TRACE_GROUPED}" ]; then
TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:yes"
fi
if [ -n "${TRACE_RESOURCE}" ]; then
TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:yes --cfg=tracing/uncategorized:yes"
fi
if [ -n "${TRACE_VIVA}" ]; then
TRACEOPTIONS="${TRACEOPTIONS} --cfg=viva/categorized:smpi_cat.plist --cfg=viva/uncategorized:smpi_uncat.plist"
fi
fi
##---------------------- end SMPI TRACING OPTIONS ---------------------------------
export SMPI_GLOBAL_SIZE=${NUMPROCS}
if [ -n "${KEEP}" ] ; then
echo ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
if [ ${HOSTFILETMP} = 1 ] ; then
echo "Generated hostfile ${HOSTFILE} keeped."
fi
if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} keeped."
fi
fi
${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
status=$?
if [ -z "${KEEP}" ] ; then
if [ -z "${PLATFORM}" ]; then
rm ${PLATFORMTMP}
fi
if [ ${HOSTFILETMP} = 1 ] ; then
rm ${HOSTFILE}
fi
if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
rm ${UNROLLEDHOSTFILE}
fi
rm ${APPLICATIONTMP}
fi
exit $status
|